#include <iostream>
#include <sstream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <list>
#include <stack>

#define max(x,y) ((x) > (y) ? (x) : (y))
#define min(x,y) ((x) < (y) ? (x) : (y))

using namespace std;

int main(void)
{
    
    while (1) {
        
        int n;
        string trademark;
        
        vector<string> names;
        vector<double> prices;
        vector<string> actions;
        
        vector<double> sellprices;
        map<double,vector<int> > sellers;
        
        vector<double> buyprices;
        map<double,vector<int> > buyers;
        
        cin >> n >> trademark;
        
        if (n == 0) break;
        
        for (int i=0; i<n; ++i) {
            string name, action;
            double price;
            cin >> name >> action >> price;
            
            names.push_back(name);
            prices.push_back(price);
            actions.push_back(action);
            
            if (action == "sell") {
                if (sellers.find(price) == sellers.end()) {
                    sellers[price] = vector<int>();
                    sellprices.push_back(price);
                }
                sellers[price].push_back(i);
            } else /*if (action == "buy")*/ {
                if (buyers.find(price) == buyers.end()) {
                    buyers[price] = vector<int>();
                    buyprices.push_back(price);
                }
                buyers[price].push_back(i);
            }
        }
        
        sort(sellprices.begin(), sellprices.end());
        sort(buyprices.begin(), buyprices.end());
        
        cout << trademark << endl;
        
        int len = names.size();
        for (int i=0; i<len; ++i) {
            cout << names[i] << ":";
            vector<int> toout;
            if (actions[i] == "sell") {
                for (int j=buyprices.size()-1; (j>=0) && (buyprices[j]>=prices[i]); --j) {
                    for (vector<int>::iterator k = buyers[buyprices[j]].begin(); k != buyers[buyprices[j]].end(); ++k) {
                        toout.push_back(*k);
                    }
                }
            } else {
                int lb = sellprices.size();
                for (int j=0; (j<lb) && (sellprices[j]<=prices[i]); ++j) {
                    for (vector<int>::iterator k = sellers[sellprices[j]].begin(); k != sellers[sellprices[j]].end(); ++k) {
                        toout.push_back(*k);
                    }
                }
            }
            
            if (toout.size() == 0) {
                cout << " NO-ONE";
            } else {
                sort(toout.begin(), toout.end());
                for (vector<int>::iterator k = toout.begin(); k != toout.end(); ++k) {
                    cout << " " << names[*k];
                }
            }
            cout << endl;
        }
        
    
    }
    
    
    
    return 0;
}

